Bug 1900790 - Track all resource counts via telemetry
Summary: Track all resource counts via telemetry
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: OpenShift Container Platform
Classification: Red Hat
Component: Telemeter
Version: 4.7
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
: 4.7.0
Assignee: Clayton Coleman
QA Contact: Junqi Zhao
URL:
Whiteboard:
: 1869910 (view as bug list)
Depends On:
Blocks: 1900792
TreeView+ depends on / blocked
 
Reported: 2020-11-23 17:39 UTC by Clayton Coleman
Modified: 2021-02-24 15:35 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
: 1900792 (view as bug list)
Environment:
Last Closed: 2021-02-24 15:35:25 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2020:5633 0 None None None 2021-02-24 15:35:55 UTC

Description Clayton Coleman 2020-11-23 17:39:51 UTC
Transcribe all etcd_object_counts (number of all objects) into
cluster resource usage for reporting in cluster telemetry.

The data about how many instances of a CRD are in use on the cluster
is a key question for analyzing the success and health of a cluster
as well as for understanding how a cluster can be more successful.
From a configuration perspective, it indicates use of core platform
features. From an operator perspective, it shows adoption and usage
in a way that installation stats alone do not capture. From a support
perspective it highlights interactions between operators that may
help problem resolution.

On an average cluster this increases the series gathered by ~130
series (18 gathered today, 155 after this change, + 280 on average).
While this is a 50% increase in gathered series, it drives significant
value in all of the domains mentioned above and we believe we have
the budget to perform this increase and that using the budget on these
series specifically will deliver significant value.

In order to defend telemetry against clusters that may have thousands
of resource types, cap the cluster:usage:resources:sum series to 500.
Most have 150, and of those a large number are single or zero instance
counts, so we anticipate for the vast majority of clusters 500 is
enough to get reasonable workload and prevent a full cardinality
explosion.

Comment 2 Junqi Zhao 2020-11-26 10:50:51 UTC
tested with 4.7.0-0.nightly-2020-11-25-114114, "cluster:usage:resources:sum" record rule is as below and the metric works well
# oc -n openshift-monitoring get cm prometheus-k8s-rulefiles-0 -oyaml
...
      - expr: topk(500, max(etcd_object_counts) by (resource))
        record: cluster:usage:resources:sum
...

Comment 4 Luis Sanchez 2021-01-11 21:29:52 UTC
*** Bug 1869910 has been marked as a duplicate of this bug. ***

Comment 6 errata-xmlrpc 2021-02-24 15:35:25 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory (Moderate: OpenShift Container Platform 4.7.0 security, bug fix, and enhancement update), and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2020:5633


Note You need to log in before you can comment on or make changes to this bug.